Description

String encoding issue at glideFactoryLib.py

Steve identified a TypeError exception at line 1715 at glideFactoryLib.py when trying to submit glideins.
The error happens when trying to encode userdata which is "str" and not "bytes".

Incoming classad

condor_status -—-any -constraint 'MyType=="glideclient"' -1 944163_FNAL_HEPCLOUD_GOOGLE_us-centrall
—a_custom-16-32768@gfactory_instance_cmssrv258@gfactory_service_cmssrv258@hepcsvc03-fnal-gov_hepcl
oud_decisionengine.cms_google_passthrough
AuthenticatedIdentity = "hepcloudDEsvc03@cmssrv258.fnal.gov"
AuthenticationMethod = "GSI"
ClientName = "hepcsvc03-fnal-gov_hepcloud_decisionengine.cms_google_passthrough"
CollectorHost = "cmssrv258.fnal.gov"
FactoryName = "FNAL_HEPCLOUD_GOOGLE_us-centrall-a_custom-16-32768@gfactory_instance_cmssrv258@gfac
tory_service_cmssrv258"
FrontendHAMode = "master"
FrontendName = "hepcsvc03-fnal-gov_hepcloud_decisionengine"
GLIDEIN_In_Downtime = "False"
GlideinEncParamAuthFile = "ee834837£f3ce27d0802d6048fcd5aa4l"
GlideinEncParamGlideinProxy = "5fb6ab72f9e5da2f£f785e0f0ebcab5572"
GlideinEncParamSecurityClass = "(Oad945aaaa274c62563db02aa819%9a462"
GlideinEncParamSecurityName = "f1d3cd3ad5061ddb09ebb87b77aal4d5"
GlideinEncParamVMId = "8c0ff74e9378a0dbfc664ec887d36a581cl4ce99014fc986fcf3caff6£f1451255e688£695£f0
6442a282748c04a0aa84a067a56f4a2db08aeb3eb88c20050£485"
GlideinMonitorGlideinsFailed = 0.0
GlideinMonitorGlideinsIdle = 0.0

GlideinMonitorGlideinsIdleCores = 0

0.
GlideinMonitorGlideinsRunning = 0.0
GlideinMonitorGlideinsRunningCores = 0.0
GlideinMonitorGlideinsTotal = 0.0
GlideinMonitorGlideinsTotalCores = 0.0
GlideinMonitorIdle = 10.0
GlideinMonitorIdle_3600 = 0.0
GlideinMonitorIdleAll = 1
GlideinMonitor0OldIdle = 1
GlideinMonitorProxyIdle = 1
GlideinMonitorRunning = 0.0
GlideinMonitorRunningHere = 0.0
GlideinMonitorVomsIdle = 10.0
GlideinMyType = "glideclient"

GlideinParamCONDOR_VERSION = "8.8.8"

GlideinParamGLIDECLIENT_Rank = "1"

GlideinParamGLIDECLIENT_RegNode = "cmssrv258.fnal.gov"

GlideinParamGLIDEIN_CCB = "hepcsvc02.fnal.gov:9620-9625;hepcsvc04.fnal.gov:9620-9625"
GlideinParamGLIDEIN_Collector = "cmssrv22l.fnal.gov:9620-9730;cmssrv276.fnal.gov:9620-9730"
GlideinParamGLIDEIN_VO_NAME = "CMS"

GlideinParamUSE_MATCH_AUTH = "True"
GlideinWMSVersion = "Decision Engine - v0.01"

GroupName = "cms_google_passthrough”

LastHeardFrom = 1615397450

MyType = "glideclient"

Name = "944163_FNAL_HEPCLOUD_GOOGLE_us-centrall-a_custom-16-32768Q@gfactory_instance_cmssrv258Qgfac
tory_service_cmssrv258@hepcsvc03-fnal-gov_hepcloud_decisionengine.cms_google_passthrough"
RegEncIdentity = "c714718114326a61b%a0elc20£f4£38cbcd47494£49892bc88675dedlef859cfc5¢c5903adbf8abb09
b93c24al14c433766"

RegEncKeyCode = "960a8112873cb4b7d096e8be78940325987£5da6a836bb0£f544909a346a82f16166bad0a5463edc62
c695983ec5d39703fbcf6el061£f056889cd57d4d07ecd864557£9¢c28a0a237b3a01a2d4c666794c2386475ced7¢c89029%e7
clb5a6bfb95120fc2f0b449ebf660b4£095cfal04660cdf606bc93389a38196472b0b3822601108d29502352f2a8f4ea3973
5b6cab51bl127732af37b8225e68ed38b99cc694dc5a345a342c594afb779¢c596045780face87e7e9564012bd0££78c8421c
£8f26400a29dfee904b2f07e61e6a967f065478e4963655ded6151205ac5f55eabal82dd56d5250012feab2ffc92718f5e
40b600222cd33b0d88ad649193fe06478b75£d5"

RegGlidein = "FNAL_HEPCLOUD_GOOGLE_us-centrall-a_custom-16-32768@gfactory_instance_cmssrv258@gfact
ory_service_cmssrv258"

ReqgIdleGlideins = 1.0

RegMaxGlideins = 4.0

RegName = "FNAL_HEPCLOUD_GOOGLE_us-centrall-a_custom-16-32768@gfactory_instance_cmssrv258@gfactory

_service_cmssrv258"

RegPubKeyID = "12758bd2898a2fe2d5f6a27e8d019d0e"

RegRemoveExcess = "NO"

UpdateSequenceNumber = 12.0

WebDescriptFile = "description.l3aa8A.cfg"

WebDescriptSign = "d15da0ec61619f5e963179185c8c547ba92fff1b"

WebGroupDescriptFile = "description.l3aa8A.cfg"

WebGroupDescriptSign = "2£785525efb6f5bd6£f50116005c7dc2bll7elab7"

WebGroupURL = "http://hepcsvc03.fnal.gov:8319/vofrontend/stage/group_cms_google_passthrough"

WebMonitoringURL = "http://hepcsvc03.fnal.gov:8319/vofrontend/monitor"

WebSignType = "shal"

WebURL = "http://hepcsvc03.fnal.gov:8319/vofrontend/stage"

Exception

[2021-03-10 11:08:44,995] DEBUG: glideFactoryLib:659: Submitting 1 glideins

[2021-03-10 11:08:45,036] DEBUG: glideFactoryLib:1664: params: {'GLIDEIN_CCB': 'hepcsvc02.fnal.gov

:9620-9625; hepcsvc04.fnal.gov:9620-9625"', 'GLIDEIN_VO_NAME': 'CMS', 'GLIDEIN_Collector': 'cmssr

v221.fnal.gov:9620-9730;cmssrv276.fnal.gov:9620-9730', 'USE_MATCH_AUTH': 'True', 'CONDOR_VERSION':
'8.8.8"'", 'GLIDECLIENT_Rank': 'l', 'GLIDECLIENT_RegNode': 'cmssrv258.fnal.gov', 'GLIDEIN_Report

_Failed': 'NEVER', 'CONDOR_OS': 'default', 'CONDOR_ARCH': 'default', 'GLIDEIN_Job_Max_Time': 34800

, 'MIN_DISK_GBS': 1, 'UPDATE_COLLECTOR_WITH TCP': 'True', 'VM_MAX LIFETIME': '2600000', 'USE_CC

B': 'True', 'VM_DISABLE_SHUTDOWN': 'False'}

[2021-03-10 11:08:45,036] DEBUG: glideFactoryLib:1665: submit_credentials.security_credentials: {'

GlideinProxy': '/var/lib/gwms-factory/client-proxies/user_frontend_2/glidein_gfactory_instance_

cmssrv258/credential_hepcsvc03-fnal-gov_hepcloud_decisionengine.cms_google_passthrough_735400_comp

ressed', 'AuthFile': '/var/lib/gwms-factory/client-proxies/user_frontend_2/glidein_gfactory_ins

tance_cmssrv258/credential_hepcsvc03-fnal-gov_hepcloud_decisionengine.cms_google_passthrough_94416
3'}
[2021-03-10 11:08:45,036] DEBUG: glideFactoryLib:1666: submit_credentials.identity_credentials: {'
frontend_condortoken': '/var/lib/gwms—-factory/client-proxies/user_frontend_2/glidein_gfactory_i
nstance_cmssrv258/FNAL_HEPCLOUD_GOOGLE_us—-centrall—-a_custom—-16-32768.idtoken', 'frontend_scitoken'
'/var/lib/gwms-factory/client-proxies/user_frontend_2/glidein_gfactory_instance_cmssrv258/FNA
L_HEPCLOUD_GOOGLE_us-centrall-a_custom-16-32768.scitoken', 'VMId': 'projects/hepcloud-fnal/global/
images/nick-sl7-singl', 'VMType': 'projects/hepcloud-fnal/zones/us-centrall-a/machineTypes/cust
om-16-81920"', 'RemoteUsername': None}
[2021-03-10 11:08:45,036] DEBUG: glideFactoryLib:1714: Userdata ini file:
[glidein_startup]
args = -v std —-name gfactory_instance_cmssrv258 -entry FNAL_HEPCLOUD_GOOGLE_us-centrall-a_custom-1
6-32768 -clientname hepcsvc03-fnal-gov_hepcloud_decisionengine.cms_google_passthrough -schedd s
chedd_glideins2@cmssrv258.fnal.gov —-proxy None —-factory gfactory_service_cmssrv258 -web http://cms
srv258.fnal.gov:8319/factory/stage -sign aa5f43db2ed84cae83d48d9d0£593e225f0cfl1f0 —-signentry 86
fb9fdedf353392b9c4882d64a77752cbbb26a8 -signtype shal -descript description.l2jacp.cfg -descripten
try description.l2jacp.cfg —-dir AUTO -param_GLIDEIN_Client hepcsvc03-fnal-gov_hepcloud_decision
engine.cms_google_passthrough -submitcredid 944163 -slotslayout partionable —-clientweb http://hepc
svc03.fnal.gov:8319/vofrontend/stage —-clientsign d15da0ec61619f5e963179185c8c547ba92ffflb -clie
ntsigntype shal -clientdescript description.l3aa8A.cfg -clientgroup cms_google_passthrough -client
webgroup http://hepcsvc03.fnal.gov:8319/vofrontend/stage/group_cms_google_passthrough -clientsi
gngroup 2£785525efb6f5bd6£50116005c7dc2bll7ela57 —clientdescriptgroup description.l3aa8A.cfg -para
m_GLIDEIN_CCB hepcsvc02.dot, fnal.dot,gov.colon, 9620.minus, 9625.semicolon, hepcsvc04.dot, fnal.dot
,gov.colon, 9620.minus, 9625 —-param_GLIDEIN_VO_NAME CMS -param_GLIDEIN_Collector cmssrv22l.dot,fnal.
dot,gov.colon, 9620.minus, 9730.semicolon, cmssrv276.dot, fnal.dot,gov.colon, 9620.minus, 9730 —-param
_USE_MATCH_AUTH True -param_CONDOR_VERSION 8.dot,8.dot,8 -param_GLIDECLIENT_Rank 1 -param_ GLIDECLI
ENT_RegNode cmssrv258.dot, fnal.dot,gov —-param_GLIDEIN_Report_Failed NEVER -param_CONDOR_OS defa
ult -param_CONDOR_ARCH default -param GLIDEIN_Job_Max_Time 34800 -param_MIN_DISK_GBS 1 -param_UPDA
TE_COLLECTOR_WITH_TCP True -param_VM_MAX LIFETIME 2600000 -param_USE_CCB True -param_VM_ DISABLE
_SHUTDOWN False

proxy_file_name = pilot_proxy

webbase= http://cmssrv258.fnal.gov:8319/factory/stage

[vm_properties]

max_lifetime = 2600000
contextualization_type = GCE
disable_shutdown = False
admin_email = UNSUPPORTED
email_logs = False

[2021-03-10 11:08:45,038] DEBUG: glideFactoryLib:1729: Error setting up submission environment (in
gce section)
[2021-03-10 11:08:45,039] ERROR: glideFactoryLib:1730: Error setting up submission environment (in
gce section)
Traceback (most recent call last):
File "/usr/lib/python3.6/site-packages/glideinwms/factory/glideFactoryLib.py", line 1715, in get
_submit_environment
ini = baseo6td.bbdencode (ini)
File "/usr/lib64/python3.6/base6d.py", line 58, in b6dencode
encoded = binascii.b2a_base64 (s, newline=False)
TypeError: a bytes-like object is required, not 'str'
[2021-03-10 11:08:45,088] DEBUG: glideFactoryLib:1761: Error setting up submission environment: a
bytes-like object is required, not 'str'
[2021-03-10 11:08:45,088] ERROR: glideFactoryLib:1762: Error setting up submission environment: a
bytes-like object is required, not 'str'
Traceback (most recent call last):
File "/usr/lib/python3.6/site-packages/glideinwms/factory/glideFactoryLib.py", line 1715, in get
_submit_environment
ini = baseotc4.bb6dencode (ini)
File "/usr/lib64/python3.6/base64.py", line 58, in bé6dencode
encoded = binascii.b2a_base64 (s, newline=False)
TypeError: a bytes-like object is required, not 'str'
[2021-03-10 11:08:45,088] WARNING: glideFactoryLib:669: Unexpected error submiting glideins
[2021-03-10 11:08:45,088] ERROR: glideFactoryLib:670: Unexpected error submiting glideins
Traceback (most recent call last):
File "/usr/lib/python3.6/site-packages/glideinwms/factory/glideFactoryLib.py", line 662, in keep
IdleGlideins
log=log, factoryConfig=factoryConfig)
File "/usr/lib/python3.6/site-packages/glideinwms/factory/glideFactoryLib.py", line 1415, in sub
mitGlideins
entry_env.append('%$s=%s' % (var, os.environ[var]))
AttributeError: 'NoneType' object has no attribute 'append'

History

#1 - 04/05/2021 11:42 AM - Bruno Coimbra

- Assignee set to Bruno Coimbra

#2 - 04/05/2021 03:26 PM - Bruno Coimbra

- Status changed from New to Feedback

| fixed the issue Steve reported, and another additional encoding issue | found when debugging.
Changes are in branch v39/25620.

#3 - 04/05/2021 03:26 PM - Bruno Coimbra

- Assignee changed from Bruno Coimbra to Marco Mambelli
